#ifndef SYS_POV_PROTO_BASE_H
#define SYS_POV_PROTO_BASE_H

#include <vector>

#include "base/thread.h"

POVMS_SPEC_QueueNode *POVMS_SPEC_QueueOpen();
void POVMS_SPEC_QueueClose(POVMS_SPEC_QueueNode *q);
void *POVMS_SPEC_QueueReceive(POVMS_SPEC_QueueNode *q, int *l, bool blocking, bool yielding);
int POVMS_SPEC_QueueSend(POVMS_SPEC_QueueNode *q, void *p, int l);
int POVMS_SPEC_AddressFromStream(POVMSAddress *a, POVMSStream *s, int z);
int POVMS_SPEC_AddressToStream(POVMSAddress a, POVMSStream *s, int *z);
int POVMS_SPEC_AddressToStreamSize(POVMSAddress a);

namespace pov
{

using namespace std;
using namespace pov_base;

inline bool Sys_Parse_Path_String(const UCS2String& s, UCS2String& v, vector<UCS2String>& f, UCS2String& n)
{
	UCS2String q;

	if(s.empty() == true)
		return true;

	if(s[0] == '/')
		v = '/';

	for(size_t i = 0; i < s.length(); i++)
	{
		if(s[i] == '/')
		{
			if(q.empty() == false)
				f.push_back(q);
			q.clear();
		}
		else
			q += s[i];
	}

	n = q;

	return true;
}

}

#endif
