/*******************************************************************************
 * console.h
 *
 * This file contains ... TODO ...
 *
 * from Persistence of Vision Ray Tracer ('POV-Ray') version 3.7.
 * Copyright 1991-2003 Persistence of Vision Team
 * Copyright 2003-2010 Persistence of Vision Raytracer Pty. Ltd.
 * ---------------------------------------------------------------------------
 * NOTICE: This source code file is provided so that users may experiment
 * with enhancements to POV-Ray and to port the software to platforms other
 * than those supported by the POV-Ray developers. There are strict rules
 * regarding how you are permitted to use this file. These rules are contained
 * in the distribution and derivative versions licenses which should have been
 * provided with this file.
 *
 * These licences may be found online, linked from the end-user license
 * agreement that is located at http://www.povray.org/povlegal.html
 * ---------------------------------------------------------------------------
 * POV-Ray is based on the popular DKB raytracer version 2.12.
 * DKBTrace was originally written by David K. Buck.
 * DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
 * ---------------------------------------------------------------------------
 * $File: //depot/povray/spec-3.7/source/frontend/console.h $
 * $Revision: #2 $
 * $Change: 5047 $
 * $DateTime: 2010/06/30 07:58:31 $
 * $Author: thorsten $
 *******************************************************************************/

#ifndef POVRAY_FRONTEND_CONSOLE_H
#define POVRAY_FRONTEND_CONSOLE_H

#include "base/textstreambuffer.h"

#include "frontend/configfrontend.h"

#include <string>

namespace pov_frontend
{

using namespace pov_base;

class Console : public TextStreamBuffer
{
	public:
		Console(unsigned int wrapwidth = 80);
		virtual ~Console();

		virtual void Initialise() = 0;
		virtual void Output(const string&) = 0;
	private:
		void lineoutput(const char *str, unsigned int chars);
};

}

#endif // POVRAY_FRONTEND_CONSOLE_H
