/*******************************************************************************
 * processrenderoptions.h
 *
 * This file contains ... TODO ...
 *
 * from Persistence of Vision Ray Tracer ('POV-Ray') version 3.7.
 * Copyright 1991-2003 Persistence of Vision Team
 * Copyright 2003-2010 Persistence of Vision Raytracer Pty. Ltd.
 * ---------------------------------------------------------------------------
 * NOTICE: This source code file is provided so that users may experiment
 * with enhancements to POV-Ray and to port the software to platforms other
 * than those supported by the POV-Ray developers. There are strict rules
 * regarding how you are permitted to use this file. These rules are contained
 * in the distribution and derivative versions licenses which should have been
 * provided with this file.
 *
 * These licences may be found online, linked from the end-user license
 * agreement that is located at http://www.povray.org/povlegal.html
 * ---------------------------------------------------------------------------
 * POV-Ray is based on the popular DKB raytracer version 2.12.
 * DKBTrace was originally written by David K. Buck.
 * DKBTrace Ver 2.0-2.12 were written by David K. Buck & Aaron A. Collins.
 * ---------------------------------------------------------------------------
 * $File: //depot/povray/spec-3.7/source/frontend/processrenderoptions.h $
 * $Revision: #2 $
 * $Change: 5047 $
 * $DateTime: 2010/06/30 07:58:31 $
 * $Author: thorsten $
 *******************************************************************************/

#ifndef POVRAY_FRONTEND_PROCESSRENDEROPTIONS_H
#define POVRAY_FRONTEND_PROCESSRENDEROPTIONS_H

#include "base/processoptions.h"
#include "frontend/configfrontend.h"

namespace pov_frontend
{

using namespace pov_base;

class ProcessRenderOptions : public ProcessOptions
{
	public:
		ProcessRenderOptions();
		~ProcessRenderOptions();
	protected:
		virtual int ReadSpecialOptionHandler(INI_Parser_Table *, char *, POVMSObjectPtr);
		virtual int ReadSpecialSwitchHandler(Cmd_Parser_Table *, char *, POVMSObjectPtr, bool);
		virtual int WriteSpecialOptionHandler(INI_Parser_Table *, POVMSObjectPtr, OTextStream *);
		virtual bool WriteOptionFilter(INI_Parser_Table *);
		virtual int ProcessUnknownString(char *, POVMSObjectPtr);
		int ParseFileType(char, POVMSType, int*, bool* pHas16BitGreyscale = NULL);
		char UnparseFileType(int);

		virtual ITextStream *OpenFileForRead(const char *, POVMSObjectPtr);
		virtual OTextStream *OpenFileForWrite(const char *, POVMSObjectPtr);

		ITextStream *OpenINIFileStream(const char *, unsigned int, POVMSObjectPtr);
};

}

#endif // POVRAY_FRONTEND_PROCESSRENDEROPTIONS_H
